#!/usr/bin/perl

use CGI::Carp qw(fatalsToBrowser);

print "Content-type:text/html\n\n";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}
######
#DATE#
######
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);

@days =(Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday);

@months =(January,Febuary,March,April,May,June,July,August,September,October,November,December);

$year += 1900;

if (($mday==1) || ($mday==21) || ($mday==31)) {
	$format="st";
}
elsif (($mday==2) || ($mday==22)) {
	$format="nd";
}
elsif (($mday==3) || ($mday==23)) {
	$format="rd";
}
else {
	$format="th";
}
print "Server Date: $months[$mon] $mday$format, $year | ";
##########
#END DATE#
##########
######
#TIME#
######
if ($ENV{'REQUEST_METHOD'} eq 'GET') {
	@pairs = split(/&/, $ENV{'QUERY_STRING'});
} elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
	read (STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);
} else {
	print "Content-type: text/html\n\n";
	print "<P>Use Post or Get";
}

foreach $pair (@pairs) {
	($key, $value) = split (/=/, $pair);
	$key =~ tr/+/ /;
	$key =~ s/%([a-fA-F0-9] [a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9] [a-fA-F0-9])/pack("C", hex($1))/eg;

	$value =~s/<!--(.|\n)*-->//g;

	if ($formdata{$key}) {
		$formdata{$key} .= ", $value";
	} else {
		$formdata{$key} = $value;
	}
}

$format="$formdata{'format'}";

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
$min=sprintf("%02d", $min);
$sec=sprintf("%02d", $sec);

print "Server Time: $hour:$min:$sec";
#########
#ENDTIME#
#########
###################
# START DICE CODE #
###################

print "<html><head><title>Form Output</title></head><body>";
print "<h2>Results from FORM post</h2>\n";

foreach $key ("numdice","sides","posmodifier","negmodifier","name","textarea") {
    print "$key = $FORM{$key}<br>";
}

$sides = $FORM{'sides'};
$posmodifier = $FORM{'posmodifier'};
$negmodifier = $FORM{'negmodifier'};
$name = $FORM{'name'};

$numdice = $FORM{'numdice'};

# roll the various dice
for ( my $i = 1; $i <= $numdice; $i++ ) {
  $dice[$i] = rand($sides);
  $dice[$i] = int($dice[$i]);
  $dice[$i] = $dice[$i]+1;
}

# add up the dice
for ( my $i = 1; $i <= $numdice; $i++ ) {
  print "roll " . $i . " = " . $dice[$i] ."<br>\n";
  $total += $dice[$i]; # same as $total = $total + $dice[$i];
}

$total = $total+$posmodifier;
$total = $total-$negmodifier;

print "Dice Roll from $name at $ENV{'REMOTE_ADDR'} = $total<br>";
print "</body></html>";

#Dangerous stuff:
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/\n/ /g; # replace newlines with spaces
    $value =~ s/\r//g;  # remove hard returns
    $value =~ s/\cM//g; # delete ^M's
    $FORM{$name} = $value;
}

open(OUTF,">>data.txt") or dienice("Couldn't open data.txt for writing: $!");

# This locks the file so no other CGI can write to it at the
# same time...
flock(OUTF,2);
# Reset the file pointer to the end of the file, in case
# someone wrote to it while we waited for the lock...
seek(OUTF,0,2);

$year = $year+1900;

print OUTF "------------------------------<br>";
print OUTF "Dice Roll from $name at $ENV{'REMOTE_ADDR'}<br>";
print OUTF "Server Date: $months[$mon] $mday$format, $year | ";
print OUTF "Server Time: $hour:$min:$sec | ";

foreach $key ("numdice","sides","textarea") {

     print OUTF "$key = $FORM{$key} | ";
}

print OUTF "<br>";

# add up the dice
for ( my $i = 1; $i <= $numdice; $i++ ) {
   print OUTF "roll " . $i . " = " . $dice[$i] ."<br>";
}
print OUTF "Positive Modifer = +$posmodifier<br>";
print OUTF "Negative Modifer = -$negmodifier<br>";
print OUTF "Total =  $total<br>";

#End adding/printing to file
print OUTF "------------------------------";
print OUTF "\n";

print <<EndHTML;
<html><head><title>Thank You</title></head>
<body>
<a href="http://www.votomsonline.com/vobascripts/form.html">Return to the roller!</a><p>
</body></html>
EndHTML

# The dienice subroutine, for handling errors.
sub dienice {
    my($errmsg) = @_;
    print "<h2>Error</h2>\n";
    print "$errmsg<p>\n";
    print "</body></html>\n";
    exit;
}